// This file is auto-generated. Please do not edit.

/**************************************************************************
*  Copyright 2012 KISS Institute for Practical Robotics                  *
*                                                                        *
*  This file is part of libkovan.                                        *
*                                                                        *
*  libkovan is free software: you can redistribute it and/or modify      *
*  it under the terms of the GNU General Public License as published by  *
*  the Free Software Foundation, either version 2 of the License, or     *
*  (at your option) any later version.                                   *
*                                                                        *
*  libkovan is distributed in the hope that it will be useful,           *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*  GNU General Public License for more details.                          *
*                                                                        *
*  You should have received a copy of the GNU General Public License     *
*  along with libkovan. Check the LICENSE file in the project root.      *
*  If not, see <http://www.gnu.org/licenses/>.                           *
**************************************************************************/

/*!
* \file motors.h
* \brief Provides methods for working with motors.
* \author Braden McDorman
* \copyright KISS Insitute for Practical Robotics
* \defgroup motor Motors
*/

#ifndef _MOTORS_H_
#define _MOTORS_H_

#include "export.h"

#include "vtable.h"

#ifdef __cplusplus
extern "C" {
#endif

/*!
* \param[in] motor The motor port.
* \ingroup motor
*/

/*!
* \param[in] motor The motor port.
* \ingroup motor
*/

/*!
* \param[in] motor The motor port.
* \ingroup motor
*/

/*!
* \param[in] motor The motor port.
* \ingroup motor
*/

/*!
* \param[in] motor The motor port.
* \ingroup motor
*/

/*!
* \param[in] motor The motor port.
* \see move_at_velocity
* \ingroup motor
*/


/*!
* \param[in] motor The motor port.
* \see move_to_position
* \ingroup motor
*/


/*!
* \param[in] motor The motor port.
* \see move_relative_position
* \ingroup motor
*/

/*!
* \param[in] motor The motor port.
* \ingroup motor
*/

/*!
* \param[in] motor The motor port.
* \ingroup motor
*/

/*!
* \param[in] motor The motor port.
* \ingroup motor
*/

/*!
* \param[in] motor The motor port.
* \ingroup motor
*/

/*!
* \param[in] motor The motor port.
* \ingroup motor
*/

/*!
* \param[in] motor The motor port.
* \see block_motor_done
* \ingroup motor
*/

/*!
* \param[in] motor The motor port.
* \ingroup motor
*/

/*!
* \param[in] motor The motor port.
* \ingroup motor
*/

/*!
* Moves the given motor forward at full power
* \param motor the motor's port.
* \ingroup motor
*/

/*!
* Moves the given motor backward at full power
* \param motor the motor's port.
* \ingroup motor
*/

/*!
* Moves a motor at a percent power.
*
* \param[in] motor The motor port.
* \param[in] percent The power of the motor, between -100 and 100.
*
* \ingroup motor
*/

/*!
* Turns the specified motor off.
* \param motor the motor's port.
* \ingroup motor
*/

/*!
* Turns all motors off.
* \see ao
* \ingroup motor
*/

/*!
* Turns all motors off.
* \ingroup motor
*/

VTABLE_FUNC(get_motor_position_counter, int, (int motor), (motor));
VTABLE_FUNC(gmpc, int, (int motor), (motor));
VTABLE_FUNC_VOID(clear_motor_position_counter, (int motor), (motor));
VTABLE_FUNC_VOID(cmpc, (int motor), (motor));
VTABLE_FUNC(move_at_velocity, int, (int motor, int velocity), (motor,velocity));
VTABLE_FUNC(mav, int, (int motor, int velocity), (motor,velocity));
VTABLE_FUNC(move_to_position, int, (int motor, int speed, int goal_pos), (motor,speed,goal_pos));
VTABLE_FUNC(mtp, int, (int motor, int speed, int goal_pos), (motor,speed,goal_pos));
VTABLE_FUNC(move_relative_position, int, (int motor, int speed, int delta_pos), (motor,speed,delta_pos));
VTABLE_FUNC(mrp, int, (int motor, int speed, int delta_pos), (motor,speed,delta_pos));
VTABLE_FUNC_VOID(set_pid_gains, (int motor, short p, short i, short d, short pd, short id, short dd), (motor,p,i,d,pd,id,dd));
VTABLE_FUNC_VOID(get_pid_gains, (int motor, short *p, short *i, short *d, short *pd, short *id, short *dd), (motor,p,i,d,pd,id,dd));
VTABLE_FUNC(freeze, int, (int motor), (motor));
VTABLE_FUNC(get_motor_done, int, (int motor), (motor));
VTABLE_FUNC_VOID(block_motor_done, (int motor), (motor));
VTABLE_FUNC_VOID(bmd, (int motor), (motor));
VTABLE_FUNC(setpwm, int, (int motor, int pwm), (motor,pwm));
VTABLE_FUNC(getpwm, int, (int motor), (motor));
VTABLE_FUNC_VOID(fd, (int motor), (motor));
VTABLE_FUNC_VOID(bk, (int motor), (motor));
VTABLE_FUNC_VOID(motor, (int motor, int percent), (motor,percent));
VTABLE_FUNC_VOID(off, (int motor), (motor));
VTABLE_FUNC_VOID(alloff, (), ());
VTABLE_FUNC_VOID(ao, (), ());


#ifdef __cplusplus
}
#endif


#endif

